#include <stdio.h>
#include <stdlib.h>

struct prodotto {
       char nome[20];
       int codice;
       int cfornitore;
       int quantita;
       int tipo;
       };

struct fornitore {
       char nome[20];
       int codice;
       char telefono[15];
       int tipo;
       };
       
struct atomo {
       struct fornitore dato;
       struct atomo *next;
       };

void leggi_prodotto(struct prodotto *p)
{
     printf("Nome prodotto ");
     scanf("%s",p->nome);
     printf("Codice prodotto ");
     scanf("%d",&p->codice);
     printf("Cod. fornitore ");
     scanf("%d",&p->cfornitore);
     printf("Quantita' ");
     scanf("%d",&p->quantita);
     printf("Tipo ");
     scanf("%d",&p->tipo);
} 
     
void ins_prodotto(struct prodotto **R,int *n,struct prodotto p) 
 {
     struct prodotto *a;
     
     a=realloc(*R,(*n+1)*sizeof(struct prodotto));
     if(a)
      {
          *R=a;
          (*R)[*n]=p;
          (*n)++;
      }
      else printf("Mem non allocata\n");
}

void visualizza_prodotti(struct prodotto *R, int n)
{
     int i;
     
     for(i=0;i<n;i++)
      {
        printf("Nome prodotto: %s\n",R[i].nome);
        printf("Codice: %d\n\n",R[i].codice);
      }
}
void leggi_fornitore(struct fornitore *f)
{
     printf("Nome: ");
     scanf("%s",f->nome);
     printf("Codice: ");
     scanf("%d",&f->codice);
     printf("Telefono: ");
     scanf("%s",f->telefono);
     printf("tipo: ");
     scanf("%d",&f->tipo);
}
void in_testa(struct atomo **testa, struct fornitore x)
{
     struct atomo *aux;
     
     aux=malloc(sizeof(struct atomo));
     if(aux)
       {     aux->dato=x;
             aux->next=*testa;
             *testa=aux;
       }
     else printf("memoria non allocata\n");
}
void visualizza_fornitori(struct atomo *testa)
{
     struct atomo *l;
     
     l=testa;
     while(l!=NULL)
     { printf("Nome fornitore: %s",l->dato.nome);
       printf("Codice: %d\n\n",l->dato.codice);
       l=l->next;
     }
}
void da_testa(struct atomo **testa)
{
     struct atomo *a;
    if(*testa!=NULL)
    { 
     a=*testa;
     *testa=a->next;
     free(a);
    } 
}
    
void elimina(struct atomo **testa, int x)
{
     struct atomo *l1,*l2;
     
     if(*testa==NULL)
        return;
     if((*testa)->dato.codice==x) /* trovato in testa*/
          {
            da_testa(testa);
            return;
          }
     l1=(*testa)->next;
     l2=*testa;
     while(l1!=NULL)
       if(l1->dato.codice==x) /* trovato*/
         {l2->next=l1->next;
          free(l1);
          return;
          }
       else {l1=l1->next;
             l2=l2->next;
            }
     printf("Non trovato\n\n");
     }
          
     
                 
main()
{
      struct prodotto *T[6];
      int N[6];
      
      struct atomo *L[6];
      
      
      struct prodotto p;
      int tipo;
      struct fornitore f;
      int cfornitore;
      int scelta;
      
      
      /*inizializzazione tabella*/
        for(tipo=0;tipo<6;tipo++)
          {
            T[tipo]=NULL;
            N[tipo]=0;
          }
      /*inizializzazione lista*/
        for(tipo=0;tipo<6;tipo++)
           L[tipo]=NULL;
      
      do {
          printf("\nScegli tra\n");
          printf("1) Ins prodotto\n");
          printf("2) visualizza prodotto\n");
          printf("3) Ins fornitore\n");
          printf("4) Vis fornitori\n");
          printf("5) Elimina fornitore\n");
          printf("0) fine\n");
          scanf("%d",&scelta);
          switch(scelta) {
          case 1:  leggi_prodotto(&p);
                   tipo=p.tipo;
                   ins_prodotto(&T[tipo],&N[tipo],p);
                   break;
          case 2:  printf("Tipo prodotto\n");
                   scanf("%d",&tipo);
                   visualizza_prodotti(T[tipo],N[tipo]);
                   break;
          case 3:  leggi_fornitore(&f);
                   tipo=f.tipo;
                   in_testa(&L[tipo],f);
                   break;
          case 4:  printf("Tipo prodotto\n");
                   scanf("%d",&tipo);
                   visualizza_fornitori(L[tipo]);
                   break;
          case 5:  printf("Tipo prodotto\n");
                   scanf("%d",&tipo);
                   printf("Codice fornitore \n");
                   scanf("%d",&cfornitore);
                   elimina(&L[tipo],cfornitore);
                   break;
          default:;
          }
          } while (scelta!=0);
          
          
          /* liberazione della memoria*/
          for(tipo=0;tipo<6;tipo++)
            free(T[tipo]);
            
          for(tipo=0;tipo<6;tipo++)
              while(L[tipo]!=NULL)
                da_testa(&L[tipo]);}  
            
          
                   
            
            
      
      
       
       
