#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct cliente {
       char nome[20];
       char codfiscale[17];
       int tipo;
       };

struct atomo {
       struct cliente dato;
       struct atomo *next;
       };

struct coda {
       struct atomo *primo,*ultimo;
       };
       
struct operazione {
       char codfiscale[17];       
       float importo;
       char data[10];
       int tipo;
       };
void leggi_cliente(struct cliente *c)
{
     printf("Nome: ");
     scanf("%s",c->nome);
     printf("Cod. fiscale: ");
     scanf("%s",c->codfiscale);
     printf("Tipo operazione (0..3): ");
     scanf("%d",&c-> tipo);
}

void in_coda(struct coda *q, struct cliente c)
{
     struct atomo *a;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
        return;
     a->dato=c;
     a->next=NULL;
     if(q->primo==NULL)
        q->primo=a;
     else q->ultimo->next=a;
     q->ultimo=a;
}
 
void visualizza_coda( struct coda q)
{
     struct atomo *p;
     
     p=q.primo;
     while(p!=NULL)
      {
        printf("Nome: %s\n",p->dato.nome);
        printf("Cod. fiscale: %s\n",p->dato.codfiscale);
        p=p->next;
      }
}
             
struct operazione out_coda(struct coda *q)
{
       struct operazione op;
       struct atomo *a;
       
       a=q->primo;
       q->primo=a->next;
       strcpy(op.codfiscale, a->dato.codfiscale);
       op.tipo=a->dato.tipo;
       printf("Importo operazione: ");
       scanf("%f",&op.importo);
       printf("Data operzione: ");
       scanf("%s",op.data);
       
       free(a);
       if(q->primo==NULL) 
         q->ultimo=NULL;
       
       return op;
}

void ins_operazione( struct operazione **R, int *n, struct operazione x)
{
     struct operazione *a;
     
     a=(struct operazione *) realloc(*R,(*n+1)*sizeof(struct operazione));
     if(a)
       {  *R=a;
           (*R)[*n]=x;
           (*n)++;
       }
     else printf("Mem non allocata\n");
}
           
void visualizza_tabella(struct operazione *TB[4], int N[4])
{
     char data[10];
     int t,i;
     
     printf("Data: ");
     scanf("%s",data);
     for(t=0;t<4;t++)
       for(i=0;i<N[t];i++)
          if (strcmp(TB[t][i].data,data)==0) 
            { printf("Cod. fiscale: %s\n",TB[t][i].codfiscale);
              printf("Importo: %f\n\n",TB[t][i].importo);
            }
}          
       
void out_coda_classica (struct coda *q)
{
     struct atomo *a;
     
     a=q-> primo;
     q->primo=a->next;
     free(a);
     if(q->primo==NULL)
       q->ultimo= NULL;
}    
       
       
             
main() {

struct coda Q[4];
struct operazione *T[4];
int N[4];
int scelta;
int tipo;
struct cliente cl;
struct operazione op;

 /* inizializzazione code */
    for(tipo=0;tipo<4;tipo++)
       {
         Q[tipo].primo=NULL;
         Q[tipo].ultimo=NULL;
       }
       
 /* inizializzazione tabella */
     for(tipo=0;tipo<4;tipo++)
         { T[tipo]=NULL;
            N[tipo]=0;
         }
         
  do {
      printf("Scegli\n");
      printf("1) In coda\n");
      printf("2) vis coda\n");
      printf("3) Servizio coda e ins in tabella\n");
      printf("4) Visualizzazione operazioni per data\n");
      printf("0) fine\n\n");
      scanf("%d",&scelta);
      switch(scelta) {
      case 1:  leggi_cliente(&cl);
               tipo=cl.tipo;
               in_coda(&Q[tipo], cl);
               break;
      case 2:  printf("Tipo coda da visualizzare\n");
               scanf("%d",&tipo);
               visualizza_coda(Q[tipo]);
               break;
      case 3:  printf("Tipo coda da servire\n");
               scanf("%d",&tipo);
               if(Q[tipo].primo !=NULL) /* Coda non vuota*/
               { op=out_coda(&Q[tipo]);
                  ins_operazione(&T[tipo],&N[tipo],op);
                }
                else printf("Coda vuota\n\n");
               break;
      case 4: visualizza_tabella(T,N);
              break;
      default:;
      }
      } while (scelta!=0);
      
      /* liberazione della memoria della tabella */
        for(tipo=0;tipo<4;tipo++)
           free(T[tipo]);
        
       /* liberazione della memoria delle code */
        for(tipo=0;tipo<4;tipo++)
          while(Q[tipo].primo!=NULL) /* fino a quando la coda non e' vuota*/  
               out_coda_classica(&Q[tipo]);
}
       
       
